Program Life;
Uses Dos,Crt;
const
 XSize            = 79;
 YSize            = 23;
type
 LifeBoard        = Array[1..XSize,1..YSize] of Byte;
var
 Generation      :LongInt;
 B1              :LifeBoard;
 S               :String;

Function Min(const x,y: LongInt): LongInt;
begin
 if x>y then Min:=y else Min:=x;
end;

Function Va(const s: string): longint;
var
 code:   Integer;
 vas:    Longint;
begin
 Val(s,vas,code);
 Va:=vas
end;

Function  LZ(tal: longint;antal: byte): String;
var
 loop:   Byte;
 temp:   String[20];

begin
 Str(Tal,Temp);
 While length(temp)<antal do temp:='0'+temp;
lz:=temp;
end;

Function Neighbours(const X,Y: Word;const Board: LifeBoard): Byte;
var
 N              :Byte;
begin
 N:=0;
 { 1 2 3 }
 { 4   5 }
 { 6 7 8 }
 {1} if (X-1>0)      AND (Y-1>0)      AND (Board[X-1,Y-1]>0) then Inc(N);
 {2} if                  (Y-1>0)      AND (Board[X,Y-1]>0)   then Inc(N);
 {3} if (X+1<=XSize) AND (Y-1>0)      AND (Board[X+1,Y-1]>0) then Inc(N);
 {4} if (X-1>0)                       AND (Board[X-1,Y]>0)   then Inc(N);
 {5} if (X+1<=XSize)                  AND (Board[X+1,Y]>0)   then Inc(N);
 {6} if (X-1>0) AND (Y+1<=YSize)      AND (Board[X-1,Y+1]>0) then Inc(N);
 {7} if             (Y+1<=YSize)      AND (Board[X,Y+1]>0)   then Inc(N);
 {8} if (X+1<=XSize) AND (Y+1<=YSize) AND (Board[X+1,Y+1]>0) then Inc(N);
 Neighbours:=N;
end;

Procedure DumpBoard(const Board: LifeBoard);
var
 x,y            :Byte;
begin
 GotoXY(1,1);
 for y:=1 to YSize do
  begin
   for x:=1 to XSize do if Board[X,Y]<>0 then Write('*') else Write('');
   WriteLn;
  end;
end;

Procedure LoadBoard(const FileName: PathStr;var Board: LifeBoard);
var
 T              :Text;
 S              :String;
 x,y            :byte;
begin
 FillChar(Board,SizeOf(Board),0);
 Assign(T,FileName);
 Reset(T);
 ReadLn(T,Generation);
  for Y:=1 to YSize do
   begin
    ReadLn(T,S);
    for X:=1 to Min(Length(S),XSize) do if S[X]='*' then Board[X,Y]:=Ord('*');
   end;
 Close(T);
end;

Procedure SaveBoard(const FileName: PathStr;var Board: LifeBoard);
var
 T              :Text;
 S              :String;
 x,y            :Byte;
begin
 Assign(T,FileName);
 Rewrite(T);
 WriteLn(T,Generation);
 for y:=1 to YSize do begin
  S:='';
  for x:=1 to XSize do if Board[X,Y]>0 then S:=S+'*' else S:=S+'';
  WriteLn(T,S);
 end;
 Close(T);
end;

Procedure EvolveBoard(var Board: LifeBoard);
var
 x,y,n          :Byte;
 B2             :LifeBoard;
 isAlive        :Boolean;
begin
 FillChar(B2,SizeOf(B2),0);
 for y:=1 to YSize do
  for x:=1 to XSize do
   begin
    if Board[X,Y]>0 then isAlive:=True else isAlive:=False;
    n:=Neighbours(X,Y,Board);
    if isAlive then
     begin
      if (N>3) or (N<2) then isAlive:=False
     end else if n=3 then isAlive:=True;
    if isAlive then B2[X,Y]:=Ord('*') else B2[X,Y]:=0;
   end;
 Move(B2,Board,SizeOf(B2));
 Inc(Generation);
end;

Procedure EditBoard(var Board: LifeBoard);
var
 x,y            :Byte;
 ch             :Char;
begin
 ClrScr;
 DumpBoard(B1);
 x:=1;
 y:=1;
 Repeat
  GotoXY(1,YSize+1);
  Write('X=',Lz(X,2),' Y=',Lz(Y,2),'  N=',Neighbours(X,Y,Board));

  GotoXY(X,Y);
  Ch:=ReadKey;

  if Ch=#32 then begin
    if Board[X,Y]>0 then
     begin
      Board[X,Y]:=0;
      Write('',#8);
     end else begin
      Board[X,Y]:=Ord('*');
      Write('*',#8);
     end;
   end;

  if Ch=#0 then begin
   Ch:=ReadKey;
   if Ch=#75 then if X>1     then Dec(X);
   if Ch=#77 then if X<XSize then Inc(X);
   If Ch=#72 then if Y>1     then Dec(Y);
   if Ch=#80 then if Y<YSize then Inc(Y);
  end;

 Until CH=#13;
end;

Procedure RandomizeBoard(const Percent: Byte;var Board: LifeBoard);
var
 x,y,b       :Byte;
begin
 for y:=1 to YSize do
 for x:=1 to XSize do
      begin
       b:=Random(100);
       if Percent>B then B:=Ord('*') else B:=0;
       Board[X,Y]:=b;
      end;
 Generation:=0;
end;

BEGIN
 Randomize;
 ClrScr;
{ if Exist(ParamStr(1)) then LoadBoard(ParamStr(1),B1);}
 DumpBoard(B1);
While S[1]<>'Q' do
 begin
  GotoXY(1,YSize+1);
  Write('                                                          ');
  GotoXY(1,YSize+1);
  Write('[',Generation,']> '); ReadLn(S);
  S[1]:=Upcase(S[1]);

  { EDIT }
  if S[1]='E' then EditBoard(B1);

  { NEXT GENERATION }
  if S[1]='N' then
   begin
    EvolveBoard(B1);
    ClrScr;
    DumpBoard(B1);
   end;

  { SAVE }
  if S[1]='S' then
   begin
    Write('Save; Filename: ');
    ReadLn(S);
    if S>'' then SaveBoard(S,B1);
   end;

  { LOAD }
  if S[1]='L' then
   begin
    Write('Load; Filename: ');
    ReadLn(S);
    if S>'' then LoadBoard(S,B1);
    DumpBoard(B1);
   end;

  { CLEAR }
  if S[1]='C' then
   begin
    Write('Clear; (enter to abort)? ');
    ReadLn(S);
    if S>'' then begin
      FillChar(B1,SizeOf(B1),0);
      Generation:=0;
      DumpBoard(B1);
     end;
   end;

  { RANDOM }
  if S[1]='R' then
   begin
    Write('Random; % of live cell? ');
    ReadLn(S);
    if S>'' then RandomizeBoard(Va(S),B1);
    DumpBoard(B1);
   end;

  { HELP }
  if (S[1]='H') or (S[1]='?') then
   begin
    Write('(E)dit  (N)ext generation  (L)oad  (S)ave  (C)lear  (R)andom');
   end;
 end;
END.
